;;;                                            (8 Damen.scm)
;;; Im Programm Laufzeiten wird eine "Funktion mit Zustand" mit dem 
;;; Namen "Zeit" definiert, also objektorientiert gearbeitet.
;;; Moegliche Aufrufe: (Zeit 'Start) (Zeit 'stop) oder (Zeit 'miss)
(load "laufzeiten.scm")
;;; 
;;; Gute HG+T   (hierarchic generate and test)
;;; -----------------------------------------------------------------
(load "breakpoint.scm")
    
;;; ===== Nachfolger ================================================
; Die Nachfolgerfunktion generiert nur die zulaessigen Felder.
(define
  (Nachfolger zustand max-zahl)
  (define
    (nachf index akku)
    (cond
      [(zero? index) akku]
      [(member index zustand) (nachf (sub1 index) akku)]
      [(diagonal-besetzt? (cons index zustand))
       (nachf (sub1 index) akku)]
      [else
       (nachf (sub1 index) (cons (cons index zustand) akku))]))
    (nachf max-zahl '()))

;;; ===== diagonal-besetzt? =========================================
; Testet die Diagonalen.
(define
  (diagonal-besetzt? zustand)
  (define
    (diagonal? liste rauf runter)
    (cond
      [(null? liste) #f]
      [(= rauf (first liste)) #t]
      [(= runter (first liste)) #t]
      [else
       (diagonal? (rest liste) (add1 rauf) (sub1 runter))]))
  (diagonal? (rest zustand) (add1 (first zustand)) (sub1 (first zustand))))

;;; ===== Tiefensuche ===============================================
(define
  (Tiefensuche max-Zahl)
  (Zeit 'start)
  (define
    (t-s Alternativen Damen)    
    (cond
      [(= (length Damen) max-Zahl)
       (ausgabe (Zeit 'miss) "ms")
       (Darstellung (first Damen))
       (first Damen)]
      [(null? Alternativen) #f]
      [(t-s
        (Nachfolger (first Alternativen) max-Zahl)
        (cons (first Alternativen) Damen))]
      [else
       (t-s
       (rest Alternativen)
        Damen)]))
  (t-s (Nachfolger '() max-Zahl) '()))
;;; ===== Darstellung ===============================================
(define
  (Darstellung Damen)
  (let loop           ; "named let": lokale Funktion als "Schleife"
    ((Anzahl (length Damen))
     (Damen Damen))
    (cond
      [(null? Damen) (newline)]
      [else
       (stelle-Zeile-dar Anzahl (first Damen))
       (loop Anzahl (rest Damen))])))

;;; ===== stelle-Zeile-dar ==========================================
(define
  (stelle-Zeile-dar Anzahl Spalte)
  (let loop
    ((Index 1))
    (cond
      [(> Index Anzahl) (newline)]
      [(= Index Spalte) 
       (display " D ")
       (loop (add1 Index))]
      [else
       (display " * ")
       (loop (add1 Index))])))
  
;;;  4 -->       1 ms
;;;  5 -->       1 ms
;;;  6 -->       0 ms
;;;  7 -->       0 ms
;;;  8 -->       2 ms
;;;  9 -->       1 ms
;;; 10 -->       2 ms
;;; 11 -->       2 ms
;;; 12 -->       4 ms
;;; 13 -->       5 ms
;;; 14 -->      84 ms
;;; 15 -->      65 ms
;;; 16 -->     212 ms
;;; 17 -->     181 ms
;;; 18 -->     991 ms
;;; 19 -->     112 ms
;;; 20 -->    5313 ms
;;; 21 -->     336 ms
;;; 22 -->   52741 ms ca. 1 min
;;; 23 -->     956 ms
;;; 24 -->   15201 ms
;;; 25 -->    2035 ms
;;; 26 -->   16967 ms
;;; 27 -->   21603 ms
;;; 28 -->  146537 ms ca. 2 min
;;; 29 -->   78937 ms
;;; =================================================================
(Tiefensuche 8)
